JUCE: AudioPluginFormat Class Reference

JUCE

Public Types | Public Member Functions | Protected Member Functions | List of all members
AudioPluginFormat Class Referenceabstract
juce_audio_processors » format

The base class for a type of plugin format, such as VST, AudioUnit, LADSPA, etc. More...

`#include <juce_AudioPluginFormat.h>`

Inheritance diagram for AudioPluginFormat:

## Public Types
using | PluginCreationCallback = std::function< void(std::unique_ptr< AudioPluginInstance >, const String &)>
| A callback lambda that is passed to createPluginInstanceAsync() More...

## Public Member Functions
| ~AudioPluginFormat () override
| Destructor. More...
virtual String | getName () const =0
| Returns the format name. More...
virtual void | findAllTypesForFile (OwnedArray< PluginDescription > &results, const String &fileOrIdentifier)=0
| This tries to create descriptions for all the plugin types available in a binary module file. More...
std::unique_ptr< AudioPluginInstance > | createInstanceFromDescription (const PluginDescription &, double initialSampleRate, int initialBufferSize)
| Tries to recreate a type from a previously generated PluginDescription. More...
std::unique_ptr< AudioPluginInstance > | createInstanceFromDescription (const PluginDescription &, double initialSampleRate, int initialBufferSize, String &errorMessage)
| Same as above but with the possibility of returning an error message. More...
void | createPluginInstanceAsync (const PluginDescription &description, double initialSampleRate, int initialBufferSize, PluginCreationCallback)
| Tries to recreate a type from a previously generated PluginDescription. More...
virtual bool | fileMightContainThisPluginType (const String &fileOrIdentifier)=0
| Should do a quick check to see if this file or directory might be a plugin of this format. More...
virtual String | getNameOfPluginFromIdentifier (const String &fileOrIdentifier)=0
| Returns a readable version of the name of the plugin that this identifier refers to. More...
virtual bool | pluginNeedsRescanning (const PluginDescription &)=0
| Returns true if this plugin's version or date has changed and it should be re-checked. More...
virtual bool | doesPluginStillExist (const PluginDescription &)=0
| Checks whether this plugin could possibly be loaded. More...
virtual bool | canScanForPlugins () const =0
| Returns true if this format needs to run a scan to find its list of plugins. More...
virtual bool | isTrivialToScan () const =0
| Should return true if this format is both safe and quick to scan - i.e. More...
virtual StringArray | searchPathsForPlugins (const FileSearchPath &directoriesToSearch, bool recursive, bool allowPluginsWhichRequireAsynchronousInstantiation=false)=0
| Searches a suggested set of directories for any plugins in this format. More...
virtual FileSearchPath | getDefaultLocationsToSearch ()=0
| Returns the typical places to look for this kind of plugin. More...

## Protected Member Functions
| AudioPluginFormat ()
virtual void | createPluginInstance (const PluginDescription &, double initialSampleRate, int initialBufferSize, PluginCreationCallback)=0
| Implementors must override this function. More...
virtual bool | requiresUnblockedMessageThreadDuringCreation (const PluginDescription &) const =0
| Returns true if instantiation of this plugin type must be done from a non-message thread. More...

## Detailed Description

The base class for a type of plugin format, such as VST, AudioUnit, LADSPA, etc.

See also
  AudioPluginFormatManager

## Member Typedef Documentation

## ◆ PluginCreationCallback

using AudioPluginFormat::PluginCreationCallback = std::function<void (std::unique_ptr<AudioPluginInstance>, const String&)>

A callback lambda that is passed to createPluginInstanceAsync()

## Constructor & Destructor Documentation

## ◆ ~AudioPluginFormat()

AudioPluginFormat::~AudioPluginFormat | ( |  | ) |
| override

Destructor.

## ◆ AudioPluginFormat()

AudioPluginFormat::AudioPluginFormat | ( |  | ) |
| protected

## Member Function Documentation

## ◆ getName()

virtual String AudioPluginFormat::getName | ( |  | ) | const
| pure virtual

Returns the format name.

E.g. "VST", "AudioUnit", etc.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ findAllTypesForFile()

virtual void AudioPluginFormat::findAllTypesForFile | ( | OwnedArray< PluginDescription > & | results,
|  | const String & | fileOrIdentifier
| ) |  |
| pure virtual

This tries to create descriptions for all the plugin types available in a binary module file.

The file will be some kind of DLL or bundle.

Normally there will only be one type returned, but some plugins (e.g. VST shells) can use a single DLL to create a set of different plugin subtypes, so in that case, each subtype is returned as a separate object.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ createInstanceFromDescription() [1/2]

std::unique_ptr< AudioPluginInstance > AudioPluginFormat::createInstanceFromDescription | ( | const PluginDescription & | ,
|  | double | initialSampleRate,
|  | int | initialBufferSize
| ) |  |

Tries to recreate a type from a previously generated PluginDescription.

See also
  AudioPluginFormatManager::createInstance

## ◆ createInstanceFromDescription() [2/2]

std::unique_ptr< AudioPluginInstance > AudioPluginFormat::createInstanceFromDescription | ( | const PluginDescription & | ,
|  | double | initialSampleRate,
|  | int | initialBufferSize,
|  | String & | errorMessage
| ) |  |

Same as above but with the possibility of returning an error message.

See also
  AudioPluginFormatManager::createInstance

## ◆ createPluginInstanceAsync()

void AudioPluginFormat::createPluginInstanceAsync | ( | const PluginDescription & | description,
|  | double | initialSampleRate,
|  | int | initialBufferSize,
|  | PluginCreationCallback |
| ) |  |

Tries to recreate a type from a previously generated PluginDescription.

When the plugin has been created, it will be passed to the caller via an asynchronous call to the PluginCreationCallback lambda that was provided.

See also
  AudioPluginFormatManager::createPluginInstanceAsync

## ◆ fileMightContainThisPluginType()

virtual bool AudioPluginFormat::fileMightContainThisPluginType | ( | const String & | fileOrIdentifier | ) |
| pure virtual

Should do a quick check to see if this file or directory might be a plugin of this format.

This is for searching for potential files, so it shouldn't actually try to load the plugin or do anything time-consuming.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ getNameOfPluginFromIdentifier()

virtual String AudioPluginFormat::getNameOfPluginFromIdentifier | ( | const String & | fileOrIdentifier | ) |
| pure virtual

Returns a readable version of the name of the plugin that this identifier refers to.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ pluginNeedsRescanning()

virtual bool AudioPluginFormat::pluginNeedsRescanning | ( | const PluginDescription & |  | ) |
| pure virtual

Returns true if this plugin's version or date has changed and it should be re-checked.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ doesPluginStillExist()

virtual bool AudioPluginFormat::doesPluginStillExist | ( | const PluginDescription & |  | ) |
| pure virtual

Checks whether this plugin could possibly be loaded.

It doesn't actually need to load it, just to check whether the file or component still exists.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ canScanForPlugins()

virtual bool AudioPluginFormat::canScanForPlugins | ( |  | ) | const
| pure virtual

Returns true if this format needs to run a scan to find its list of plugins.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ isTrivialToScan()

virtual bool AudioPluginFormat::isTrivialToScan | ( |  | ) | const
| pure virtual

Should return true if this format is both safe and quick to scan - i.e.

if a file can be scanned within a few milliseconds on a background thread, without actually needing to load an executable.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ searchPathsForPlugins()

virtual StringArray AudioPluginFormat::searchPathsForPlugins | ( | const FileSearchPath & | directoriesToSearch,
|  | bool | recursive,
|  | bool | allowPluginsWhichRequireAsynchronousInstantiation = `false`
| ) |  |
| pure virtual

Searches a suggested set of directories for any plugins in this format.

The path might be ignored, e.g. by AUs, which are found by the OS rather than manually.

Parameters

  directoriesToSearch | This specifies which directories shall be searched for plug-ins.
  recursive | Should the search recursively traverse folders.
  allowPluginsWhichRequireAsynchronousInstantiation | If this is false then plug-ins which require asynchronous creation will be excluded.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ getDefaultLocationsToSearch()

virtual FileSearchPath AudioPluginFormat::getDefaultLocationsToSearch | ( |  | ) |
| pure virtual

Returns the typical places to look for this kind of plugin.

Note that if this returns no paths, it means that the format doesn't search in files or folders, e.g. AudioUnits.

Implemented in AudioUnitPluginFormat, LADSPAPluginFormat, VST3PluginFormat, and VSTPluginFormat.

## ◆ createPluginInstance()

virtual void AudioPluginFormat::createPluginInstance | ( | const PluginDescription & | ,
|  | double | initialSampleRate,
|  | int | initialBufferSize,
|  | PluginCreationCallback |
| ) |  |
| protectedpure virtual

Implementors must override this function.

This is guaranteed to be called on the message thread. You may call the callback on any thread.

## ◆ requiresUnblockedMessageThreadDuringCreation()

virtual bool AudioPluginFormat::requiresUnblockedMessageThreadDuringCreation | ( | const PluginDescription & |  | ) | const
| protectedpure virtual

Returns true if instantiation of this plugin type must be done from a non-message thread.

The documentation for this class was generated from the following file:

- juce_AudioPluginFormat.h